"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
exports.__esModule = true;
exports.TestingApolloClient = void 0;
var client_1 = require("@apollo/client");
// no-cache and network-only fetch policies cause an initial async event to be
// produced which is not properly caught inside of a react-testing act scope.
var invalidFetchPolicies = ['no-cache', 'network-only'];
// patch getCurrentQueryResult to protect against an initial observable event
var TestingApolloClient = /** @class */ (function (_super) {
    __extends(TestingApolloClient, _super);
    function TestingApolloClient(options) {
        return _super.call(this, options) || this;
        // this.getCurrentQueryResult = this.queryManager.getCurrentQueryResult.bind(
        //   this.queryManager,
        // );
        // this.queryManager.getCurrentQueryResult = this.getCurrentQueryResultSafe.bind(
        //   this,
        // );
    }
    TestingApolloClient.prototype.getCurrentQueryResultSafe = function (observableQuery, optimistic) {
        var result = this.getCurrentQueryResult(observableQuery, optimistic);
        result.partial = isPartial(observableQuery, result);
        return result;
    };
    return TestingApolloClient;
}(client_1.ApolloClient));
exports.TestingApolloClient = TestingApolloClient;
// detect the conditions where we need to override partial to true
// see https://github.com/apollographql/apollo-client/blob/413b41211a232911824e7ede62e41e2910ae1a25/packages/apollo-client/src/core/QueryManager.ts#L1036-L1038
function isPartial(observableQuery, _a) {
    var data = _a.data, partial = _a.partial;
    if (!observableQuery.getLastResult() &&
        invalidFetchPolicies.includes(observableQuery.options.fetchPolicy) &&
        data === undefined &&
        partial === false) {
        return true;
    }
    // if the conditions don't match we just return the original value
    return partial;
}
