import { ApolloReducerConfig, ApolloClient, PossibleTypesMap } from '@apollo/client';
import { Operations } from './operations';
import { GraphQLMock, FindOptions } from './types';
export interface Options {
    possibleTypes?: PossibleTypesMap;
    cacheOptions?: ApolloReducerConfig;
}
interface Wrapper {
    (perform: () => Promise<void>): Promise<void>;
}
export declare class GraphQL {
    readonly client: ApolloClient<unknown>;
    readonly operations: Operations;
    private readonly pendingRequests;
    private readonly wrappers;
    private readonly mockLink;
    constructor(mock: GraphQLMock | undefined, { possibleTypes, cacheOptions }?: Options);
    update(mock: GraphQLMock): void;
    resolveAll(options?: FindOptions): Promise<void>;
    wrap(wrapper: Wrapper): void;
    private handleCreate;
    private handleResolve;
}
export {};
