"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
exports.__esModule = true;
exports.InflightLink = void 0;
var client_1 = require("@apollo/client");
var InflightLink = /** @class */ (function (_super) {
    __extends(InflightLink, _super);
    function InflightLink(options) {
        var _this = _super.call(this) || this;
        _this.options = options;
        return _this;
    }
    InflightLink.prototype.request = function (operation, nextLink) {
        var _this = this;
        if (nextLink == null || !nextLink) {
            throw new Error('The memory link must not be a terminating link');
        }
        var resolver;
        var promise = new Promise(function (resolve) {
            resolver = resolve;
        });
        var request = {
            operation: operation,
            resolve: function () {
                resolver();
                _this.options.onResolved(request);
                return promise;
            }
        };
        this.options.onCreated(request);
        return new client_1.Observable(function (observer) {
            return nextLink(operation).subscribe({
                complete: function () {
                    var complete = observer.complete.bind(observer);
                    promise.then(complete)["catch"](complete);
                },
                next: function (result) {
                    var next = observer.next.bind(observer, result);
                    promise.then(next)["catch"](next);
                },
                error: function (error) {
                    var fail = observer.error.bind(observer, error);
                    promise.then(fail)["catch"](fail);
                }
            });
        });
    };
    return InflightLink;
}(client_1.ApolloLink));
exports.InflightLink = InflightLink;
