"use strict";
exports.__esModule = true;
exports.diffVariablesForOperation = exports.assertIsGraphQL = void 0;
var jest_matcher_utils_1 = require("jest-matcher-utils");
var graphql_controller_1 = require("../graphql-controller");
function assertIsGraphQL(graphQL, _a) {
    var expectation = _a.expectation, isNot = _a.isNot;
    if (!(graphQL instanceof graphql_controller_1.GraphQL)) {
        throw new Error(jest_matcher_utils_1.matcherErrorMessage(jest_matcher_utils_1.matcherHint("." + expectation, undefined, undefined, { isNot: isNot }), jest_matcher_utils_1.RECEIVED_COLOR('received') + " value must be a @shopify/graphql-testing GraphQL object", jest_matcher_utils_1.printWithType('Received', graphQL, jest_matcher_utils_1.printReceived)));
    }
}
exports.assertIsGraphQL = assertIsGraphQL;
function diffVariablesForOperation(operation, variables, _a) {
    var _b = _a.expand, expand = _b === void 0 ? false : _b;
    return jest_matcher_utils_1.diff(variables, getObjectSubset(operation.variables, variables), {
        expand: expand
    });
}
exports.diffVariablesForOperation = diffVariablesForOperation;
// Original from https://github.com/facebook/jest/blob/master/packages/expect/src/utils.ts#L107
function getObjectSubset(object, subset) {
    if (Array.isArray(object)) {
        if (Array.isArray(subset) && subset.length === object.length) {
            return subset.map(function (sub, i) {
                return getObjectSubset(object[i], sub);
            });
        }
    }
    else if (object instanceof Date) {
        return object;
    }
    else if (typeof object === 'object' &&
        object !== null &&
        typeof subset === 'object' &&
        subset !== null) {
        var trimmed_1 = {};
        Object.keys(subset)
            .filter(function (key) { return Reflect.has(object, key); })
            .forEach(function (key) { return (trimmed_1[key] = getObjectSubset(object[key], subset[key])); });
        if (Object.keys(trimmed_1).length > 0) {
            return trimmed_1;
        }
    }
    return object;
}
