"use strict";
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
exports.__esModule = true;
exports.Operations = void 0;
var utilities_1 = require("./utilities");
var Operations = /** @class */ (function () {
    function Operations(operations) {
        this.operations = [];
        this.operations = operations ? __spreadArray([], operations) : [];
    }
    Operations.prototype[Symbol.iterator] = function () {
        return this.operations[Symbol.iterator]();
    };
    Operations.prototype.push = function () {
        var _a;
        var operations = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            operations[_i] = arguments[_i];
        }
        (_a = this.operations).push.apply(_a, operations);
    };
    Operations.prototype.all = function (options) {
        return this.filterWhere(options);
    };
    Operations.prototype.first = function (options) {
        return this.nth(0, options);
    };
    Operations.prototype.last = function (options) {
        return this.nth(-1, options);
    };
    Operations.prototype.nth = function (index, options) {
        var found = this.filterWhere(options);
        return index < 0 ? found[found.length + index] : found[index];
    };
    Operations.prototype.filterWhere = function (options) {
        if (options === void 0) { options = {}; }
        var finalOperationName = utilities_1.operationNameFromFindOptions(options);
        return finalOperationName
            ? this.operations.filter(function (_a) {
                var operationName = _a.operationName;
                return operationName === finalOperationName;
            })
            : this.operations;
    };
    return Operations;
}());
exports.Operations = Operations;
