"use strict";
exports.__esModule = true;
exports.operationTypeFromDocument = exports.operationNameFromDocument = exports.operationNameFromFindOptions = void 0;
function operationNameFromFindOptions(_a) {
    var query = _a.query, mutation = _a.mutation, operationName = _a.operationName;
    var passedOptions = [query, mutation, operationName].filter(Boolean);
    if (passedOptions.length === 0) {
        return undefined;
    }
    else if (passedOptions.length > 1) {
        throw new Error('You can only pass one of query, mutation, or operationName when finding a GraphQL operation');
    }
    return operationName || operationNameFromDocument((query || mutation));
}
exports.operationNameFromFindOptions = operationNameFromFindOptions;
function operationNameFromDocument(document) {
    return 'resolver' in document && document.resolver.resolved != null
        ? operationNameFromDocumentNode(document.resolver.resolved)
        : operationNameFromDocumentNode(document);
}
exports.operationNameFromDocument = operationNameFromDocument;
function operationTypeFromDocument(document) {
    return 'resolver' in document && document.resolver.resolved != null
        ? operationTypeFromDocumentNode(document.resolver.resolved)
        : operationTypeFromDocumentNode(document);
}
exports.operationTypeFromDocument = operationTypeFromDocument;
function operationNameFromDocumentNode(document) {
    var operation = document.definitions.filter(function (_a) {
        var kind = _a.kind;
        return kind === 'OperationDefinition';
    })[0];
    return operation && operation.name && operation.name.value;
}
function operationTypeFromDocumentNode(document) {
    var operation = document.definitions.filter(function (_a) {
        var kind = _a.kind;
        return kind === 'OperationDefinition';
    })[0];
    return operation && operation.operation;
}
